Attribute VB_Name = "Transparency"
Option Explicit
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal HDC As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal HDC As Long, ByVal crColor As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal HDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal HDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal HDC As Long, ByVal hObject As Long) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal HDC As Long) As Long

Sub TransparentBlt(dsthdc As Long, X As Integer, Y As Integer, Width As Integer, Height As Integer, sourcehDC As Long, xSrc As Integer, ySrc As Integer, TransColor As Long)
    Dim maskDC As Long      'DC for the mask
    Dim tempDC As Long      'DC for temporary data
    Dim hMaskBmpA As Long    'Bitmap for mask
    Dim hTempBmpA As Long    'Bitmap for temporary data
    Dim hMaskBmpB As Long    'Bitmap for mask
    Dim hTempBmpB As Long    'Bitmap for temporary data
    Dim tempbmp As Long
    Dim tempbmp2 As Long
    Dim srchDC As Long
    
    srchDC = CreateCompatibleDC(sourcehDC)
    tempbmp = CreateCompatibleBitmap(sourcehDC, Width, Height)
    tempbmp2 = SelectObject(srchDC, tempbmp)
    BitBlt srchDC, 0, 0, Width, Height, sourcehDC, xSrc, ySrc, vbSrcCopy
    
    'First create some DC's. These are our gateways to assosiated bitmaps in RAM
    maskDC = CreateCompatibleDC(dsthdc)
    tempDC = CreateCompatibleDC(dsthdc)
    'Then we need the bitmaps. Note that we create a monochrome bitmap here!
    'this is a trick we use for creating a mask fast enough.
    hMaskBmpA = CreateBitmap(Width, Height, 1, 1, ByVal 0&)
    hTempBmpA = CreateCompatibleBitmap(dsthdc, Width, Height)
    '..then we can assign the bitmaps to the DCs
    hMaskBmpB = SelectObject(maskDC, hMaskBmpA)
    hTempBmpB = SelectObject(tempDC, hTempBmpA)
    'Now we can create a mask..First we set the background color to the
    'transparent color then we copy the image into the monochrome bitmap.
    'When we are done, we reset the background color of the original source.
    TransColor = SetBkColor(srchDC, TransColor)
    BitBlt maskDC, 0, 0, Width, Height, srchDC, 0, 0, vbSrcCopy
    TransColor = SetBkColor(srchDC, TransColor)
    'The first we do with the mask is to MergePaint it into the destination.
    'this will punch a WHITE hole in the background exactly were we want the
    'graphics to be painted in.
    BitBlt tempDC, 0, 0, Width, Height, maskDC, 0, 0, vbSrcCopy
    BitBlt dsthdc, X, Y, Width, Height, tempDC, 0, 0, vbMergePaint
    'Now we delete the transparent part of our source image. To do this
    'we must invert the mask and MergePaint it into the source image. the
    'transparent area will now appear as WHITE.
    BitBlt maskDC, 0, 0, Width, Height, maskDC, 0, 0, vbNotSrcCopy
    BitBlt tempDC, 0, 0, Width, Height, srchDC, 0, 0, vbSrcCopy
    BitBlt tempDC, 0, 0, Width, Height, maskDC, 0, 0, vbMergePaint
    'Both target and source are clean, all we have to do is to AND them together!
    BitBlt dsthdc, X, Y, Width, Height, tempDC, 0, 0, vbSrcAnd
    'Now all we have to do is to clean up after us and free system resources..
    
    DeleteObject (hMaskBmpB)
    DeleteObject (hTempBmpB)
    DeleteObject (hMaskBmpA)
    DeleteObject (hTempBmpA)
    DeleteObject (tempbmp)
    DeleteObject (tempbmp2)
    DeleteDC (tempDC)
    DeleteDC (maskDC)
    DeleteDC (srchDC)
End Sub


